/* Part of gjrand random number library version 3.4.0.0 or later. */
/* Copyright (C) 2004-2011 G. Jones. */
/* Licensed under the GNU General Public License version 2 or 3. */

#include "gjrand.h"
#include "inte.h"

double
gjrand_erlang(struct gjrand *g, int shape, double scale)
{
    if (shape<=0) return 0;
    if (shape==1) return gjrand_exponential(g) * scale;
    return gjrand_inte_ge1gamma(g, (double)shape, scale);
}
